import { c as J, a as K, t as Q, z as j, p as $, V as q, O as R, f as U, K as ee, F as te, i as ie, a2 as ae, a0 as re, a3 as le, v as se, a4 as ne, d as oe, B as ce, b as he, q as de, R as ue, a5 as ge, r as fe, e as Ne, y as me, M as Ie, x as xe, a6 as be, Y as Fe, o as _e, s as ye, w as Ae, E as Ce, A as Le, u as Se } from "./index-lHJRSQDR.js";
import { D as ke } from "./DataTable-D2CcVXqP.js";
import { _ as we } from "./Title-BozQM8kF.js";
import { _ as Oe, u as Ge } from "./Tooltip-BbgP5Ohx.js";
import { U as ve } from "./usePrinter-CROL2bex.js";
import { _ as pe } from "./Shape-DLqdJkvl.js";
import Me from "./BaseIcon-B7nhISKk.js";
import ze from "./vue-ui-table-sparkline-BwrPdHSV.js";
import Te from "./vue-ui-skeleton-Dnpg0mo1.js";
import { S as Pe } from "./Slicer-B1CoSpgA.js";
import Ve from "./vue-ui-accordion-BqbjckUg.js";
import { u as Z } from "./useNestedProp-Dns_abTn.js";
import { _ as Re } from "./PackageVersion-BRA8ln6K.js";
import { P as De } from "./PenAndPaper-C3N_fmQS.js";
import { resolveComponent as P, openBlock as r, createElementBlock as l, normalizeClass as V, normalizeStyle as C, createBlock as D, createCommentVNode as c, createSlots as Be, withCtx as z, renderSlot as O, normalizeProps as H, guardReactiveProps as W, createVNode as X, createElementVNode as g, Fragment as N, renderList as I, toDisplayString as S, withDirectives as He, vModelCheckbox as We, createTextVNode as Ee } from "vue";
import { _ as Ye } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Xe = J(), qe = {
  name: "vue-ui-xy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  components: {
    DataTable: ke,
    Shape: pe,
    Title: we,
    Tooltip: Oe,
    UserOptions: ve,
    BaseIcon: Me,
    TableSparkline: ze,
    Skeleton: Te,
    Slicer: Pe,
    Accordion: Ve,
    PackageVersion: Re,
    PenAndPaper: De
  },
  data() {
    this.dataset.forEach((f, t) => {
      [null, void 0].includes(f.series) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "series (number[])",
        index: t
      });
    });
    const i = this.config.downsample && this.config.downsample.threshold ? this.config.downsample.threshold : 500, s = Math.max(...this.dataset.map((f) => this.largestTriangleThreeBucketsArray({ data: f.series, threshold: i }).length)), h = {
      start: 0,
      end: s
    };
    return {
      themePalettes: K,
      themes: Q,
      slicerStep: 0,
      selectedScale: null,
      CTX: null,
      CANVAS: null,
      opacity: j,
      useSafeValues: !0,
      palette: $,
      height: 600,
      width: 1e3,
      viewBox: "0 0 1000 600",
      clientPosition: {
        x: 0,
        y: 0
      },
      canvasClientPosition: {
        x: 0,
        y: 0
      },
      icons: {
        line: "line",
        bar: "bar",
        plot: "plot"
      },
      isAnnotator: !1,
      isFullscreen: !1,
      isPrinting: !1,
      isImaging: !1,
      isTooltip: !1,
      mutableConfig: {
        dataLabels: {
          show: !0
        },
        showTooltip: !0,
        showTable: !1,
        isStacked: !1,
        useIndividualScale: !1
      },
      selectedSerieIndex: null,
      selectedRowIndex: null,
      segregatedSeries: [],
      uniqueId: J(),
      step: 0,
      tableStep: 0,
      titleStep: 0,
      slicer: h,
      __to__: null,
      maxX: s,
      showSparklineTable: !0,
      segregateStep: 0,
      sliderId: Xe,
      fontSizes: {
        xAxis: 18,
        yAxis: 12,
        dataLabels: 20,
        plotLabels: 10
      },
      plotRadii: {
        plot: 3,
        line: 3
      },
      selectedMinimapIndex: null
    };
  },
  watch: {
    dataset: {
      handler(i, s) {
        this.maxX = Math.max(...this.dataset.map((h) => this.largestTriangleThreeBucketsArray({
          data: h.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }).length)), this.slicer = {
          start: 0,
          end: this.maxX
        }, this.slicerStep += 1, this.segregateStep += 1;
      },
      deep: !0
    },
    config: {
      handler(i, s) {
        this.FINAL_CONFIG = this.prepareConfig(), this.prepareChart(), this.titleStep += 1, this.tableStep += 1;
      },
      deep: !0
    }
  },
  computed: {
    hasOptionsNoTitle() {
      return this.FINAL_CONFIG.chart.userOptions.show && (!this.FINAL_CONFIG.chart.title.show || !this.FINAL_CONFIG.chart.title.text);
    },
    minimap() {
      if (!this.FINAL_CONFIG.chart.zoom.minimap.show) return [];
      const i = this.datasetWithIds.filter((t) => !this.segregatedSeries.includes(t.id)), s = Math.max(...i.map((t) => t.series.length)), h = [];
      for (let t = 0; t < s; t += 1)
        h.push(i.map((e) => e.series[t] || 0).reduce((e, x) => (e || 0) + (x || 0), 0));
      const f = Math.min(...h);
      return h.map((t) => t + (f < 0 ? Math.abs(f) : 0));
    },
    customPalette() {
      return this.convertCustomPalette(this.FINAL_CONFIG.customPalette);
    },
    backgroundColor() {
      return this.FINAL_CONFIG.chart.backgroundColor;
    },
    slicerColor() {
      return this.FINAL_CONFIG.chart.zoom.color;
    },
    allScales() {
      const i = this.lineSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height,
        autoScaleYLabels: t.autoScaleYLabels
      })), s = this.barSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), h = this.plotSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        // FIX
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), f = [...i, ...s, ...h].flatMap((t) => t).length;
      return [...i, ...s, ...h].flatMap((t, e) => ({
        id: t.id,
        scaleLabel: t.scaleLabel,
        name: t.name,
        color: t.color,
        scale: t.scale,
        yOffset: t.yOffset,
        individualHeight: t.individualHeight,
        x: this.mutableConfig.isStacked ? this.drawingArea.left : this.drawingArea.left / f * (e + 1),
        yLabels: t.scaleYLabels || t.scale.ticks.map((x) => ({
          y: x >= 0 ? t.zero - t.individualHeight * (x / t.max) : t.zero + t.individualHeight * Math.abs(x) / t.max,
          value: x
        }))
      }));
    },
    isDataset() {
      return !!this.dataset && this.dataset.length;
    },
    chartFont() {
      const i = document.getElementById(`vue-ui-xy_${this.uniqueId}`);
      return window.getComputedStyle(i, null).getPropertyValue("font-family");
    },
    FINAL_CONFIG: {
      get: function() {
        return this.prepareConfig();
      },
      set: function(i) {
        return i;
      }
    },
    hasHighlightArea() {
      return Array.isArray(this.FINAL_CONFIG.chart.highlightArea) ? this.FINAL_CONFIG.chart.highlightArea.some((i) => i.show) : this.FINAL_CONFIG.chart.highlightArea && this.FINAL_CONFIG.chart.highlightArea.show;
    },
    highlightAreas() {
      if (Array.isArray(this.FINAL_CONFIG.chart.highlightArea))
        return this.FINAL_CONFIG.chart.highlightArea.map((s) => ({
          ...s,
          span: s.from === s.to ? 1 : s.to < s.from ? 0 : s.to - s.from + 1
        }));
      const i = this.FINAL_CONFIG.chart.highlightArea;
      return [{ ...i, span: i.from === i.to ? 1 : i.to < i.from ? 0 : i.to - i.from + 1 }];
    },
    xPadding() {
      return this.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : this.drawingArea.width / this.maxSeries / 2;
    },
    relativeZero() {
      return this.niceScale.min >= 0 ? 0 : Math.abs(this.niceScale.min);
    },
    absoluteMax() {
      return this.niceScale.max + this.relativeZero;
    },
    datasetWithIds() {
      return this.useSafeValues ? this.dataset.map((i, s) => ({
        ...i,
        series: this.largestTriangleThreeBucketsArray({
          data: i.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }),
        id: `uniqueId_${s}`
      })) : this.dataset;
    },
    safeDataset() {
      return this.useSafeValues ? this.dataset.map((i, s) => {
        const h = this.largestTriangleThreeBucketsArray({
          data: i.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        });
        return {
          ...i,
          series: h.map((f) => this.isSafeValue(f) ? f : null).slice(this.slicer.start, this.slicer.end),
          color: this.convertColorToHex(i.color ? i.color : this.customPalette[s] ? this.customPalette[s] : this.palette[s]),
          id: `uniqueId_${s}`
        };
      }) : this.dataset;
    },
    relativeDataset() {
      return this.safeDataset.map((i, s) => ({
        ...i,
        series: i.series.map((h) => h + this.relativeZero),
        absoluteValues: i.series
      })).filter((i) => !this.segregatedSeries.includes(i.id));
    },
    tableSparklineDataset() {
      return this.relativeDataset.map((i) => {
        const s = i.absoluteValues.map((h) => [void 0, null].includes(h) ? 0 : h);
        return {
          id: i.id,
          name: i.name,
          color: i.color,
          values: this.fillArray(this.maxSeries, s)
        };
      });
    },
    tableSparklineConfig() {
      return {
        responsiveBreakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint,
        roundingValues: this.FINAL_CONFIG.table.rounding,
        showAverage: !1,
        showMedian: !1,
        showTotal: !1,
        fontFamily: this.FINAL_CONFIG.chart.fontFamily,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix,
        colNames: JSON.parse(JSON.stringify(this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values)),
        thead: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        tbody: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        userOptions: {
          show: !1
        }
      };
    },
    absoluteDataset() {
      return this.safeDataset.map((i, s) => ({
        absoluteIndex: s,
        ...i,
        series: i.series.map((h) => h + this.relativeZero),
        absoluteValues: i.series,
        segregate: () => this.segregate(i),
        isSegregated: this.segregatedSeries.includes(i.id)
      }));
    },
    barSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "bar").map((i, s) => {
        this.checkAutoScaleError(i);
        const h = Math.min(...i.absoluteValues.filter((u) => ![null, void 0].includes(u))), f = Math.max(...i.absoluteValues.filter((u) => ![null, void 0].includes(u))), e = {
          ratios: i.absoluteValues.filter((u) => ![null, void 0].includes(u)).map((u) => (u - h) / (f - h)),
          valueMin: h,
          valueMax: f < 0 ? 0 : f
        }, x = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || Math.min(...i.absoluteValues.filter((u) => ![void 0, null].includes(u))) > 0 ? 0 : Math.min(...i.absoluteValues.filter((u) => ![null, void 0].includes(u)))
        }, y = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, k = 1.0000001, m = this.calculateNiceScaleWithExactExtremes(x.min, x.max === x.min ? x.max * k : x.max, y), b = this.calculateNiceScaleWithExactExtremes(e.valueMin, e.valueMax === e.valueMin ? e.valueMax * k : e.valueMax, y), T = m.min >= 0 ? 0 : Math.abs(m.min), v = 0, p = m.max + T, w = b.max + Math.abs(v), _ = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, L = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, M = this.drawingArea.bottom - _ - L * T / p, a = this.drawingArea.bottom - _ - L * v / w, o = this.absoluteDataset.filter((u) => u.type === "bar").filter((u) => !this.segregatedSeries.includes(u.id)).length, n = i.series.map((u, F) => {
          const E = this.mutableConfig.useIndividualScale ? (i.absoluteValues[F] + T) / p : this.ratioToMax(u), Y = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * F : this.drawingArea.left + this.slot.bar * s + this.slot.bar * F * o - this.barSlot / 2 - s * this.barPeriodGap;
          return {
            yOffset: this.checkNaN(_),
            individualHeight: this.checkNaN(L),
            x: this.checkNaN(Y),
            y: this.drawingArea.bottom - _ - L * E,
            value: i.absoluteValues[F],
            zeroPosition: this.checkNaN(M),
            individualMax: this.checkNaN(p),
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), d = i.absoluteValues.map((u) => b.min >= 0 ? (u - Math.abs(b.min)) / (b.max - Math.abs(b.min)) : (u + Math.abs(b.min)) / (b.max + Math.abs(b.min))), B = i.series.map((u, F) => {
          const E = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * F : this.drawingArea.left - this.slot.bar / 2 + this.slot.bar * s + this.slot.bar * F * this.absoluteDataset.filter((Y) => Y.type === "bar").filter((Y) => !this.segregatedSeries.includes(Y.id)).length;
          return {
            yOffset: this.checkNaN(_),
            individualHeight: this.checkNaN(L),
            x: this.checkNaN(E),
            y: this.checkNaN(this.drawingArea.bottom - this.checkNaN(_) - (this.checkNaN(L) * d[F] || 0)),
            value: i.absoluteValues[F],
            zeroPosition: this.checkNaN(M),
            individualMax: this.checkNaN(p),
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), A = m.ticks.map((u) => ({
          y: u >= 0 ? M - L * (u / p) : M + L * Math.abs(u) / p,
          value: u,
          prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: i
        })), G = b.ticks.map((u) => {
          const F = (u - b.min) / (b.max - b.min);
          return {
            y: u >= 0 ? a - L * F : a + L * F,
            value: u,
            prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: i
          };
        });
        return {
          ...i,
          yOffset: _,
          autoScaleYLabels: G,
          individualHeight: L,
          scaleYLabels: i.autoScaling ? G : A,
          individualScale: i.autoScaling ? b : m,
          individualMax: i.autoScaling ? w : p,
          zeroPosition: i.autoScaling ? a : M,
          plots: i.autoScaling ? B : n
        };
      });
    },
    activeSeriesLength() {
      return this.absoluteDataset.length;
    },
    activeSeriesWithStackRatios() {
      return this.assignStackRatios(this.absoluteDataset.filter((i) => !this.segregatedSeries.includes(i.id)));
    },
    lineSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "line").map((i) => {
        this.checkAutoScaleError(i);
        const s = Math.min(...i.absoluteValues.filter((u) => ![void 0, null].includes(u))), h = Math.max(...i.absoluteValues.filter((u) => ![void 0, null].includes(u))) || 1, t = {
          ratios: i.absoluteValues.filter((u) => ![null, void 0].includes(u)).map((u) => (u - s) / (h - s)),
          valueMin: s,
          valueMax: h
        }, e = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || (Math.min(...i.absoluteValues) > 0 ? 0 : Math.min(...i.absoluteValues))
        }, x = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, y = 1.0000001, k = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * y : e.max, x), m = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * y : t.valueMax, x), b = k.min >= 0 ? 0 : Math.abs(k.min), T = 0, v = k.max + Math.abs(b), p = m.max + Math.abs(T), w = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, _ = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, L = this.drawingArea.bottom - w - _ * b / v, M = this.drawingArea.bottom - w - _ * T / p, a = i.series.map((u, F) => {
          const E = this.mutableConfig.useIndividualScale ? (i.absoluteValues[F] + Math.abs(b)) / v : this.ratioToMax(u);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
            y: this.checkNaN(this.drawingArea.bottom - w - _ * E),
            value: i.absoluteValues[F],
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), o = i.absoluteValues.map((u) => m.min >= 0 ? (u - Math.abs(m.min)) / (m.max - Math.abs(m.min)) : (u + Math.abs(m.min)) / (m.max + Math.abs(m.min))), n = i.series.map((u, F) => [void 0, null].includes(i.absoluteValues[F]) ? {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
          y: L,
          value: i.absoluteValues[F],
          comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
        } : {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
          y: this.checkNaN(this.drawingArea.bottom - w - (_ * o[F] || 0)),
          value: i.absoluteValues[F],
          comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
        }), d = this.createSmoothPath(a), B = this.createSmoothPath(n), A = k.ticks.map((u) => ({
          y: u >= 0 ? L - _ * (u / v) : L + _ * Math.abs(u) / v,
          value: u,
          prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: i
        })), G = m.ticks.map((u) => {
          const F = (u - m.min) / (m.max - m.min);
          return {
            y: u >= 0 ? M - _ * F : M + _ * F,
            value: u,
            prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: i
          };
        });
        return {
          ...i,
          yOffset: w,
          autoScaleYLabels: G,
          individualHeight: _,
          scaleYLabels: i.autoScaling ? G : A,
          individualScale: i.autoScaling ? m : k,
          individualMax: i.autoScaling ? p : v,
          zeroPosition: i.autoScaling ? M : L,
          curve: i.autoScaling ? B : d,
          plots: i.autoScaling ? n : a,
          area: i.useArea ? this.mutableConfig.useIndividualScale ? this.createIndividualArea(i.autoScaling ? n : a, i.autoScaling ? M : L) : this.createArea(a) : ""
        };
      });
    },
    plotSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "plot").map((i) => {
        this.checkAutoScaleError(i);
        const s = Math.min(...i.absoluteValues.filter((A) => ![null, void 0].includes(A))), h = Math.max(...i.absoluteValues.filter((A) => ![null, void 0].includes(A))) || 1, t = {
          ratios: i.absoluteValues.filter((A) => ![null, void 0].includes(A)).map((A) => (A - s) / (h - s)),
          valueMin: s,
          valueMax: h
        }, e = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || Math.min(...i.absoluteValues) > 0 ? 0 : Math.min(...i.absoluteValues)
        }, x = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, y = 1.0000001, k = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * y : e.max, x), m = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * y : t.valueMax, x), b = k.min >= 0 ? 0 : Math.abs(k.min), T = 0, v = k.max + b, p = m.max + Math.abs(T), w = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, _ = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, L = this.drawingArea.bottom - w - _ * b / v, M = this.drawingArea.bottom - w - _ * T / p, a = i.series.map((A, G) => {
          const u = this.mutableConfig.useIndividualScale ? (i.absoluteValues[G] + Math.abs(b)) / v : this.ratioToMax(A);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * G),
            y: this.checkNaN(this.drawingArea.bottom - w - _ * u),
            value: i.absoluteValues[G],
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[G] || ""
          };
        }), o = i.absoluteValues.map((A) => m.min >= 0 ? (A - Math.abs(m.min)) / (m.max - Math.abs(m.min)) : (A + Math.abs(m.min)) / (m.max + Math.abs(m.min))), n = i.series.map((A, G) => ({
          x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * G),
          y: this.checkNaN(this.drawingArea.bottom - w - (_ * o[G] || 0)),
          value: i.absoluteValues[G],
          comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[G] || ""
        })), d = k.ticks.map((A) => ({
          y: A >= 0 ? L - _ * (A / v) : L + _ * Math.abs(A) / v,
          value: A,
          prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: i
        })), B = m.ticks.map((A) => {
          const G = (A - m.min) / (m.max - m.min);
          return {
            y: A >= 0 ? M - _ * G : M + _ * G,
            value: A,
            prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: i
          };
        });
        return {
          ...i,
          yOffset: w,
          autoScaleYLabels: B,
          individualHeight: _,
          scaleYLabels: i.autoScaling ? B : d,
          individualScale: i.autoScaling ? m : k,
          individualMax: i.autoScaling ? p : v,
          zeroPosition: i.autoScaling ? M : L,
          plots: i.autoScaling ? n : a
        };
      });
    },
    drawingArea() {
      const i = this.mutableConfig.useIndividualScale && this.FINAL_CONFIG.chart.grid.labels.show ? this.absoluteDataset.filter((s) => !this.segregatedSeries.includes(s.id)).length * (this.mutableConfig.isStacked ? 0 : this.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth) : 0;
      return {
        top: this.FINAL_CONFIG.chart.padding.top,
        right: this.width - this.FINAL_CONFIG.chart.padding.right,
        bottom: this.height - this.FINAL_CONFIG.chart.padding.bottom,
        left: this.FINAL_CONFIG.chart.padding.left + i,
        height: this.height - (this.FINAL_CONFIG.chart.padding.top + this.FINAL_CONFIG.chart.padding.bottom),
        width: this.width - (this.FINAL_CONFIG.chart.padding.right + this.FINAL_CONFIG.chart.padding.left + i)
      };
    },
    max() {
      return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax ? this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax : Math.max(...this.safeDataset.filter((i) => !this.segregatedSeries.includes(i.id)).map((i) => Math.max(...i.series)));
    },
    min() {
      if (this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin !== null)
        return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin;
      const i = Math.min(...this.safeDataset.filter((s) => !this.segregatedSeries.includes(s.id)).map((s) => Math.min(...s.series)));
      return i > 0 ? 0 : i;
    },
    niceScale() {
      return this.calculateNiceScaleWithExactExtremes(this.min, this.max < 0 ? 0 : this.max, this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps);
    },
    maxSeries() {
      return this.slicer.end - this.slicer.start;
    },
    timeLabels() {
      return this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values.slice(this.slicer.start, this.slicer.end);
    },
    slot() {
      return {
        bar: this.drawingArea.width / this.maxSeries / this.safeDataset.filter((i) => i.type === "bar").filter((i) => !this.segregatedSeries.includes(i.id)).length,
        plot: this.drawingArea.width / this.maxSeries,
        line: this.drawingArea.width / this.maxSeries
      };
    },
    barSlot() {
      const i = this.safeDataset.filter((s) => s.type === "bar").filter((s) => !this.segregatedSeries.includes(s.id)).length;
      return this.drawingArea.width / this.maxSeries / i - this.barPeriodGap * i;
    },
    barPeriodGap() {
      return this.slot.line * this.FINAL_CONFIG.bar.periodGap;
    },
    maxSlot() {
      return Math.max(...Object.values(this.slot).filter((i) => i !== 1 / 0));
    },
    table() {
      if (this.safeDataset.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const i = this.relativeDataset.map((h) => ({
        label: h.name,
        color: h.color,
        type: h.type
      })), s = [];
      return this.timeLabels.forEach((h, f) => {
        const t = [h];
        this.relativeDataset.forEach((e) => {
          t.push(this.canShowValue(e.absoluteValues[f]) ? Number(e.absoluteValues[f].toFixed(this.FINAL_CONFIG.table.rounding)) : "");
        }), s.push(t);
      }), { head: i, body: s };
    },
    dataTable() {
      const i = this.FINAL_CONFIG.table.showSum;
      let s = [""].concat(this.relativeDataset.map((e) => e.name));
      i && (s = s.concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>'));
      let h = [];
      for (let e = 0; e < this.maxSeries; e += 1) {
        const x = this.relativeDataset.map((y) => y.absoluteValues[e] ?? 0).reduce((y, k) => y + k, 0);
        h.push(
          [
            this.timeLabels[e] ?? "-"
          ].concat(this.relativeDataset.map(
            (y) => this.applyDataLabel(
              y.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : y.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
              y.absoluteValues[e] ?? 0,
              this.dataLabel({
                p: y.prefix || this.FINAL_CONFIG.chart.labels.prefix,
                v: y.absoluteValues[e] ?? 0,
                s: y.suffix || this.FINAL_CONFIG.chart.labels.suffix,
                r: this.FINAL_CONFIG.table.rounding
              })
            )
          )).concat(i ? (x ?? 0).toFixed(this.FINAL_CONFIG.table.rounding) : [])
        );
      }
      const f = {
        th: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        td: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        breakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint
      }, t = [this.FINAL_CONFIG.table.columnNames.period].concat(this.relativeDataset.map((e) => e.name)).concat(this.FINAL_CONFIG.table.columnNames.total);
      return { head: s, body: h, config: f, colNames: t };
    },
    dataTooltipSlot() {
      return {
        datapoint: this.selectedSeries,
        seriesIndex: this.selectedSerieIndex,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      };
    },
    selectedSeries() {
      return this.relativeDataset.map((i) => ({
        shape: i.shape || null,
        name: i.name,
        color: i.color,
        type: i.type,
        value: i.absoluteValues.find((s, h) => h === this.selectedSerieIndex),
        comments: i.comments || [],
        prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    tooltipContent() {
      let i = "", s = this.selectedSeries.map((t) => t.value).filter((t) => this.isSafeValue(t) && t !== null).reduce((t, e) => Math.abs(t) + Math.abs(e), 0);
      const h = this.timeLabels[this.selectedSerieIndex], f = this.FINAL_CONFIG.chart.tooltip.customFormat;
      return this.isFunction(f) && this.functionReturnsString(() => f({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      })) ? f({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      }) : (h && (i += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${this.FINAL_CONFIG.chart.tooltip.borderColor}; width:100%">${h}</div>`), this.selectedSeries.forEach((t) => {
        if (this.isSafeValue(t.value)) {
          let e = "", x = "";
          switch (this.icons[t.type]) {
            case "bar":
              e = `<svg viewBox="0 0 12 12" height="14" width="14"><rect x="0" y="0" rx="1" stroke="none" height="12" width="12" fill="${t.color}" /></svg>`;
              break;
            case "line":
              !t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape) ? x = `<circle cx="10" cy="8" r="4" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" />` : t.shape === "triangle" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "square" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "diamond" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "pentagon" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "hexagon" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" />` : t.shape === "star" && (x = `<polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" points="${q({ plot: { x: 10, y: 8 }, radius: 4 })}" />`), e = `<svg viewBox="0 0 20 12" height="14" width="20"><rect rx="3" x="0" y="6" stroke="none" height="4" width="20" fill="${t.color}" />${x}</svg>`;
              break;
            case "plot":
              if (!t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape)) {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" /></svg>`;
                break;
              }
              if (t.shape === "star") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" points="${q({ plot: { x: 6, y: 6 }, radius: 5 })}" /></svg>`;
                break;
              }
              if (t.shape === "triangle") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 6, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "square") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 6, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "diamond") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "pentagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "hexagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
          }
          i += `<div style="display:flex;flex-direction:row; align-items:center;gap:3px;"><div style="width:20px">${e}</div> ${t.name}: <b>${this.FINAL_CONFIG.chart.tooltip.showValue ? this.applyDataLabel(
            t.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : t.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
            t.value,
            this.dataLabel({
              p: t.prefix,
              v: t.value,
              s: t.suffix,
              r: this.FINAL_CONFIG.chart.tooltip.roundingValue
            }),
            { datapoint: t }
          ) : ""}</b> ${this.FINAL_CONFIG.chart.tooltip.showPercentage ? `(${U({
            v: this.checkNaN(Math.abs(t.value) / s * 100),
            s: "%",
            r: this.FINAL_CONFIG.chart.tooltip.roundingPercentage
          })})` : ""}</div>`, this.FINAL_CONFIG.chart.comments.showInTooltip && t.comments.length && t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex] && (i += `<div class="vue-data-ui-tooltip-comment" style="background:${t.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${t.color}">${t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex]}</div>`);
        }
      }), `<div style="border-radius:4px;padding:12px;font-variant-numeric: tabular-nums;color:${this.FINAL_CONFIG.chart.tooltip.color}">${i}</div>`);
    },
    svg() {
      return {
        height: this.height,
        width: this.width
      };
    },
    yLabels() {
      return this.niceScale.ticks.map((i) => ({
        y: i >= 0 ? this.zero - this.drawingArea.height * this.ratioToMax(i) : this.zero + this.drawingArea.height * this.ratioToMax(Math.abs(i)),
        value: i,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    zero() {
      return this.drawingArea.bottom - this.drawingArea.height * this.ratioToMax(this.relativeZero);
    }
  },
  mounted() {
    this.prepareChart(), document.addEventListener("mousemove", (i) => {
      this.clientPosition = {
        x: i.clientX,
        y: i.clientY
      };
    });
  },
  methods: {
    abbreviate: ee,
    adaptColorToBackground: te,
    applyDataLabel: ie,
    assignStackRatios: ae,
    calcLinearProgression: re,
    calculateNiceScaleWithExactExtremes: le,
    checkNaN: se,
    closestDecimal: ne,
    convertColorToHex: oe,
    convertConfigColors: ce,
    convertCustomPalette: he,
    createCsvContent: de,
    createSmoothPath: ue,
    createTSpans: ge,
    dataLabel: U,
    downloadCsv: fe,
    error: Ne,
    functionReturnsString: me,
    hasDeepProperty: Ie,
    isFunction: xe,
    isSafeValue: be,
    largestTriangleThreeBucketsArray: Fe,
    objectIsEmpty: _e,
    setOpacity: ye,
    shiftHue: Ae,
    translateSize: Ce,
    treeShake: Le,
    useMouse: Ge,
    useNestedProp: Z,
    toggleAnnotator() {
      this.isAnnotator = !this.isAnnotator;
    },
    getHighlightAreaPosition(i) {
      const s = this.drawingArea.left + this.drawingArea.width / this.maxSeries * (i.from - this.slicer.start), h = this.drawingArea.width / (this.slicer.end - this.slicer.start) * i.span < 0 ? 1e-5 : this.drawingArea.width / (this.slicer.end - this.slicer.start) * i.span;
      return {
        x: s < this.drawingArea.left ? this.drawingArea.left : s,
        width: h
      };
    },
    prepareConfig() {
      const i = Se().vue_ui_xy;
      if (!Object.keys(this.config || {}).length)
        return i;
      const s = this.useNestedProp({
        userConfig: this.config,
        defaultConfig: i
      });
      return this.config && this.hasDeepProperty(this.config, "chart.highlightArea") && (Array.isArray(this.config.chart.highlightArea) ? s.chart.highlightArea = this.config.chart.highlightArea : s.chart.highlightArea = [this.config.chart.highlightArea]), this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMin") ? s.chart.grid.labels.yAxis.scaleMin = this.config.chart.grid.labels.yAxis.scaleMin : s.chart.grid.labels.yAxis.scaleMin = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMax") ? s.chart.grid.labels.yAxis.scaleMax = this.config.chart.grid.labels.yAxis.scaleMax : s.chart.grid.labels.yAxis.scaleMax = null, s.theme ? {
        ...Z({
          userConfig: this.themes.vue_ui_xy[s.theme] || this.config,
          defaultConfig: s
        }),
        customPalette: this.themePalettes[s.theme] || this.palette
      } : s;
    },
    prepareChart() {
      if (this.objectIsEmpty(this.dataset) ? this.error({
        componentName: "VueUiXy",
        type: "dataset"
      }) : this.dataset.forEach((i, s) => {
        [null, void 0].includes(i.name) && this.error({
          componentName: "VueUiXy",
          type: "datasetSerieAttribute",
          property: "name (string)",
          index: s
        });
      }), this.FINAL_CONFIG.showWarnings && this.dataset.forEach((i) => {
        i.series.forEach((s, h) => {
          this.isSafeValue(s) || console.warn(`VueUiXy has detected an unsafe value in your dataset:
-----> The serie '${i.name}' contains the value '${s}' at index ${h}.
'${s}' was converted to null to allow the chart to display.`);
        });
      }), this.mutableConfig = {
        dataLabels: {
          show: !0
        },
        showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
        showTable: this.FINAL_CONFIG.showTable === !0,
        isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
        useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
      }, this.FINAL_CONFIG.responsive) {
        const s = this.$refs.chart.parentNode, { height: h, width: f } = s.getBoundingClientRect();
        let t = null, e = 0;
        this.FINAL_CONFIG.chart.title.show && (t = this.$refs.chartTitle, e = t.getBoundingClientRect().height);
        let x = null, y = 0;
        this.FINAL_CONFIG.chart.zoom.show && this.maxX > 6 && this.isDataset && (x = this.$refs.chartSlicer.$el, y = x.getBoundingClientRect().height);
        let k = null, m = 0;
        this.FINAL_CONFIG.chart.legend.show && (k = this.$refs.chartLegend, m = k.getBoundingClientRect().height);
        let b = 0;
        this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height);
        let T = 0;
        this.$refs.noTitle && (T = this.$refs.source.getBoundingClientRect().height), this.height = h - e - m - y - b - T, this.width = f, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes(), new ResizeObserver((p) => {
          for (const w of p)
            this.$refs.chartTitle && (e = this.$refs.chartTitle.getBoundingClientRect().height), this.$refs.chartSlicer && this.$refs.chartSlicer.$el && (y = this.$refs.chartSlicer.$el.getBoundingClientRect().height), this.$refs.chartLegend && (m = this.$refs.chartLegend.getBoundingClientRect().height), this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height), this.height = w.contentBoxSize[0].blockSize - e - m - y - b - 24, this.width = w.contentBoxSize[0].inlineSize, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes();
        }).observe(s);
      } else
        this.height = this.FINAL_CONFIG.chart.height, this.width = this.FINAL_CONFIG.chart.width, this.viewBox = `0 0 ${this.width} ${this.height}`, this.fontSizes.dataLabels = this.FINAL_CONFIG.chart.grid.labels.fontSize, this.fontSizes.yAxis = this.FINAL_CONFIG.chart.grid.labels.axis.fontSize, this.fontSizes.xAxis = this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize, this.fontSizes.plotLabels = this.FINAL_CONFIG.chart.labels.fontSize, this.plotRadii.plot = this.FINAL_CONFIG.plot.radius, this.plotRadii.line = this.FINAL_CONFIG.line.radius;
    },
    selectMinimapIndex(i) {
      this.selectedMinimapIndex = i;
    },
    convertSizes() {
      this.fontSizes.dataLabels = this.translateSize({
        relator: this.height,
        adjuster: 400,
        source: this.FINAL_CONFIG.chart.grid.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.yAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.axis.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.xAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.plotLabels = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.chart.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.plotRadii.plot = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.plot.radius,
        threshold: 1,
        fallback: 1
      }), this.plotRadii.line = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.line.radius,
        threshold: 1,
        fallback: 1
      });
    },
    toggleStack() {
      this.mutableConfig.isStacked = !this.mutableConfig.isStacked, this.mutableConfig.isStacked ? this.mutableConfig.useIndividualScale = !0 : this.mutableConfig.useIndividualScale = this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale;
    },
    toggleTable() {
      this.mutableConfig.showTable = !this.mutableConfig.showTable;
    },
    toggleLabels() {
      this.mutableConfig.dataLabels.show = !this.mutableConfig.dataLabels.show;
    },
    toggleTooltip() {
      this.mutableConfig.showTooltip = !this.mutableConfig.showTooltip;
    },
    checkAutoScaleError(i) {
      i.autoScaling && (this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale || console.warn(`VueUiXy (datapoint: ${i.name}) : autoScaling only works when config.chart.grid.labels.yAxis.useIndividualScale is set to true`), this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked || console.warn(`VueUiXy (datapoint: ${i.name}) : autoScaling only works when config.chart.grid.labels.yAxis.stacked is set to true`));
    },
    createArea(i) {
      if (!i[0]) return [-10, -10, "", -10, -10];
      const s = { x: i[0].x, y: this.zero }, h = { x: i.at(-1).x, y: this.zero }, f = [];
      return i.forEach((t) => {
        f.push(`${t.x},${t.y} `);
      }), [s.x, s.y, ...f, h.x, h.y].toString();
    },
    createIndividualArea(i, s) {
      if (!i[0]) return [-10, -10, "", -10, -10];
      const h = { x: i[0] ? i[0].x : Math.min(...i.filter((e) => !!e).map((e) => e.x)), y: s }, f = { x: i.at(-1) ? i.at(-1).x : Math.min(...i.filter((e) => !!e).map((e) => e.x)), y: s }, t = [];
      return i.filter((e) => !!e).forEach((e) => {
        t.push(`${e.x},${e.y} `);
      }), [h.x, h.y, ...t, f.x, f.y].toString();
    },
    createStar: q,
    createPolygonPath: R,
    fillArray(i, s) {
      let h = Array(i).fill(0);
      for (let f = 0; f < s.length && f < i; f += 1)
        h[f] = s[f];
      return h;
    },
    refreshSlicer() {
      this.slicer = {
        start: 0,
        end: Math.max(...this.dataset.map((i) => this.largestTriangleThreeBucketsArray({ data: i.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length))
      }, this.slicerStep += 1;
    },
    calcRectHeight(i) {
      return i.value >= 0 ? this.checkNaN(this.zero - i.y <= 0 ? 1e-5 : this.zero - i.y) : this.checkNaN(i.y - this.zero <= 0 ? 1e-5 : i.y - this.zero);
    },
    calcIndividualHeight(i) {
      return i.value >= 0 ? this.checkNaN(i.zeroPosition - i.y <= 0 ? 1e-5 : i.zeroPosition - i.y) : this.checkNaN(i.y - i.zeroPosition <= 0 ? 1e-5 : i.zeroPosition - i.y);
    },
    calcRectWidth() {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.slot.line - this.drawingArea.width / this.maxSeries * 0.1 : this.slot.bar;
    },
    calcRectX(i) {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? i.x + this.drawingArea.width / this.maxSeries * 0.05 : i.x + this.slot.bar / 2;
    },
    calcRectY(i) {
      return i.value >= 0 ? i.y : this.zero;
    },
    calcIndividualRectY(i) {
      return i.value >= 0 ? i.y : [null, void 0, NaN, 1 / 0, -1 / 0].includes(i.zeroPosition) ? 0 : i.zeroPosition;
    },
    canShowValue(i) {
      return ![null, void 0, NaN, 1 / 0, -1 / 0].includes(i);
    },
    findClosestValue(i, s) {
      let h = s[0], f = Math.abs(i - s[0]);
      for (let t = 1; t < s.length; t += 1) {
        const e = Math.abs(i - s[t]);
        e < f && s[t] < i && (h = s[t], f = e);
      }
      return h;
    },
    ratioToMax(i) {
      return i / (this.canShowValue(this.absoluteMax) ? this.absoluteMax : 1);
    },
    selectX(i) {
      this.$emit(
        "selectX",
        {
          dataset: this.relativeDataset.map((s) => ({
            name: s.name,
            value: [null, void 0, NaN].includes(s.absoluteValues[i]) ? null : s.absoluteValues[i],
            color: s.color,
            type: s.type
          })),
          index: i,
          indexLabel: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[i]
        }
      );
    },
    getData() {
      return this.absoluteDataset.map((i) => ({
        values: i.absoluteValues,
        color: i.color,
        name: i.name,
        type: i.type
      }));
    },
    segregate(i) {
      if (this.segregatedSeries.includes(i.id))
        this.segregatedSeries = this.segregatedSeries.filter((s) => s !== i.id);
      else {
        if (this.segregatedSeries.length + 1 === this.safeDataset.length) return;
        this.segregatedSeries.push(i.id);
      }
      this.$emit("selectLegend", this.relativeDataset.map((s) => ({
        name: s.name,
        values: s.absoluteValues,
        color: s.color,
        type: s.type
      }))), this.segregateStep += 1;
    },
    toggleTooltipVisibility(i, s = null) {
      this.isTooltip = i, i ? this.selectedSerieIndex = s : this.selectedSerieIndex = null;
    },
    toggleFullscreen(i) {
      this.isFullscreen = i, this.step += 1;
    },
    showSpinnerPdf() {
      this.isPrinting = !0;
    },
    async generatePdf() {
      this.showSpinnerPdf(), clearTimeout(this.__to__), this.isPrinting = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: i } = await import("./pdf-B7oVat64.js");
          await i({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy"
          });
        } catch (i) {
          console.error("Error generating PDF:", i);
        } finally {
          this.isPrinting = !1;
        }
      }, 100);
    },
    generateCsv() {
      const i = [[this.FINAL_CONFIG.chart.title.text], [this.FINAL_CONFIG.chart.title.subtitle.text], [""]], s = ["", ...this.table.head.map((e) => e.label)], h = this.table.body, f = i.concat([s]).concat(h), t = this.createCsvContent(f);
      this.downloadCsv({ csvContent: t, title: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy" });
    },
    showSpinnerImage() {
      this.isImaging = !0;
    },
    async generateImage() {
      this.showSpinnerImage(), clearTimeout(this.__to__), this.isImaging = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: i } = await import("./img-DGzWcJ4Y.js");
          await i({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy",
            format: "png"
          });
        } catch (i) {
          console.error("Error generating image:", i);
        } finally {
          this.isImaging = !1;
        }
      }, 100);
    }
  }
}, Ue = ["id"], Ze = {
  key: 1,
  ref: "noTitle",
  class: "vue-data-ui-no-title-space",
  style: "height:36px; width: 100%; background:transparent"
}, Je = ["viewBox"], Ke = { key: 0 }, Qe = { class: "vue-ui-xy-grid" }, je = ["stroke", "x1", "x2", "y1", "y2"], $e = ["stroke", "x1", "x2", "y1", "y2"], et = { key: 1 }, tt = ["x1", "x2", "y1", "y2", "stroke"], it = ["x1", "x2", "y1", "y2", "stroke"], at = ["x1", "x2", "y1", "y2", "stroke"], rt = { key: 3 }, lt = ["x1", "x2", "y1", "y2", "stroke"], st = ["id"], nt = ["stop-color"], ot = ["stop-color"], ct = ["stop-color"], ht = ["id"], dt = ["stop-color"], ut = ["stop-color"], gt = ["stop-color"], ft = ["id"], Nt = ["stop-color"], mt = ["stop-color"], It = ["id"], xt = ["stop-color"], bt = ["stop-color"], Ft = ["id"], _t = ["stop-color"], yt = ["stop-color"], At = ["x", "y", "height", "width", "fill"], Ct = ["x", "y", "width"], Lt = ["x", "y", "height", "width", "fill"], St = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], kt = ["width", "x", "y"], wt = { key: 0 }, Ot = ["id"], Gt = ["fill"], vt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], pt = ["x", "y", "font-size", "fill"], Mt = ["stroke", "x1", "x2", "y1", "y2"], zt = { key: 2 }, Tt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Pt = ["x", "y", "width", "height", "stroke", "stroke-width", "stroke-linecap", "stroke-linejoin", "stroke-dasharray"], Vt = { key: 4 }, Rt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Dt = ["fill", "font-size", "transform"], Bt = ["x1", "x2", "y1", "y2", "stroke"], Ht = ["x", "y", "font-size", "fill"], Wt = ["x1", "x2", "y1", "y2", "stroke"], Et = ["x", "y", "font-size", "fill"], Yt = ["width", "x", "y"], Xt = { style: { width: "100%" } }, qt = { key: 0 }, Ut = ["id"], Zt = ["fill"], Jt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Kt = ["x", "y", "font-size", "fill"], Qt = ["d", "stroke", "stroke-width", "stroke-dasharray"], jt = { key: 1 }, $t = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], ei = { key: 0 }, ti = ["d", "fill"], ii = ["d", "fill"], ai = ["d", "stroke", "stroke-width", "stroke-dasharray"], ri = { key: 2 }, li = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], si = ["width", "x", "y"], ni = { style: { width: "100%" } }, oi = { key: 3 }, ci = ["id"], hi = ["fill"], di = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], ui = ["x", "y", "font-size", "fill"], gi = { key: 5 }, fi = ["x", "y", "font-size", "fill"], Ni = ["x", "y", "font-size", "fill", "font-weight"], mi = { key: 6 }, Ii = ["x", "y", "font-size", "fill"], xi = ["x", "y"], bi = ["x", "y"], Fi = { key: 7 }, _i = ["x", "y", "font-size", "fill"], yi = ["x", "y"], Ai = ["x", "y"], Ci = ["x", "y", "font-size", "fill", "innerHTML"], Li = ["x", "y", "font-size", "fill", "innerHTML"], Si = ["x", "y", "font-size", "fill", "innerHTML"], ki = ["x", "y", "font-size", "fill", "innerHTML"], wi = ["x", "y", "width", "height", "fill", "onMouseenter"], Oi = ["font-size", "fill", "transform"], Gi = ["x", "y", "font-size", "fill"], vi = { key: 9 }, pi = ["text-anchor", "font-size", "fill", "transform"], Mi = ["x", "y", "height", "width", "onMouseenter", "onClick"], zi = { key: 10 }, Ti = ["x", "y"], Pi = ["cx", "cy", "r", "fill"], Vi = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Ri = ["onClick"], Di = {
  key: 0,
  viewBox: "0 0 20 12",
  height: "14",
  width: "20"
}, Bi = ["fill"], Hi = {
  key: 1,
  viewBox: "0 0 12 12",
  height: "14",
  width: "14"
}, Wi = ["fill"], Ei = {
  key: 9,
  ref: "chartLegend"
}, Yi = {
  key: 10,
  ref: "source",
  dir: "auto"
}, Xi = {
  style: { display: "flex", "flex-direction": "row", gap: "6px", "align-items": "center", "padding-left": "6px" },
  "data-html2canvas-ignore": ""
}, qi = ["innerHTML"];
function Ui(i, s, h, f, t, e) {
  const x = P("PenAndPaper"), y = P("Title"), k = P("UserOptions"), m = P("PackageVersion"), b = P("Shape"), T = P("Skeleton"), v = P("Slicer"), p = P("Tooltip"), w = P("BaseIcon"), _ = P("TableSparkline"), L = P("DataTable"), M = P("Accordion");
  return r(), l("div", {
    id: `vue-ui-xy_${t.uniqueId}`,
    class: V(`vue-ui-xy ${t.isFullscreen ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.FINAL_CONFIG.useCssAnimation ? "" : "vue-ui-dna"}`),
    ref: "chart",
    style: C(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color};width:100%;font-family:${e.FINAL_CONFIG.chart.fontFamily};${e.FINAL_CONFIG.responsive ? "height: 100%" : ""}`)
  }, [
    e.FINAL_CONFIG.chart.userOptions.buttons.annotator ? (r(), D(x, {
      key: 0,
      parent: i.$refs.chart,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      active: t.isAnnotator,
      onClose: e.toggleAnnotator
    }, null, 8, ["parent", "backgroundColor", "color", "active", "onClose"])) : c("", !0),
    e.hasOptionsNoTitle ? (r(), l("div", Ze, null, 512)) : c("", !0),
    e.FINAL_CONFIG.chart.title.show ? (r(), l("div", {
      key: 2,
      ref: "chartTitle",
      class: "vue-ui-xy-title",
      style: C(`font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      (r(), D(y, {
        key: `title_${t.titleStep}`,
        config: {
          title: {
            cy: "xy-div-title",
            ...e.FINAL_CONFIG.chart.title
          },
          subtitle: {
            cy: "xy-div-subtitle",
            ...e.FINAL_CONFIG.chart.title.subtitle
          }
        }
      }, null, 8, ["config"]))
    ], 4)) : c("", !0),
    e.FINAL_CONFIG.chart.userOptions.show && e.isDataset ? (r(), D(k, {
      ref: "defails",
      key: `user_options_${t.step}`,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      isPrinting: t.isPrinting,
      isImaging: t.isImaging,
      uid: t.uniqueId,
      hasTooltip: e.FINAL_CONFIG.chart.userOptions.buttons.tooltip && e.FINAL_CONFIG.chart.tooltip.show,
      hasPdf: e.FINAL_CONFIG.chart.userOptions.buttons.pdf,
      hasXls: e.FINAL_CONFIG.chart.userOptions.buttons.csv,
      hasImg: e.FINAL_CONFIG.chart.userOptions.buttons.img,
      hasLabel: e.FINAL_CONFIG.chart.userOptions.buttons.labels,
      hasTable: e.FINAL_CONFIG.chart.userOptions.buttons.table,
      hasStack: h.dataset.length > 1 && e.FINAL_CONFIG.chart.userOptions.buttons.stack,
      hasFullscreen: e.FINAL_CONFIG.chart.userOptions.buttons.fullscreen,
      isStacked: t.mutableConfig.isStacked,
      isFullscreen: t.isFullscreen,
      chartElement: i.$refs.chart,
      position: e.FINAL_CONFIG.chart.userOptions.position,
      isTooltip: t.mutableConfig.showTooltip,
      titles: { ...e.FINAL_CONFIG.chart.userOptions.buttonTitles },
      hasAnnotator: e.FINAL_CONFIG.chart.userOptions.buttons.annotator,
      isAnnotation: t.isAnnotator,
      onToggleFullscreen: e.toggleFullscreen,
      onGeneratePdf: e.generatePdf,
      onGenerateCsv: e.generateCsv,
      onGenerateImage: e.generateImage,
      onToggleTable: e.toggleTable,
      onToggleLabels: e.toggleLabels,
      onToggleStack: e.toggleStack,
      onToggleTooltip: e.toggleTooltip,
      onToggleAnnotator: e.toggleAnnotator
    }, Be({ _: 2 }, [
      i.$slots.optionTooltip ? {
        name: "optionTooltip",
        fn: z(() => [
          O(i.$slots, "optionTooltip", {}, void 0, !0)
        ]),
        key: "0"
      } : void 0,
      i.$slots.optionPdf ? {
        name: "optionPdf",
        fn: z(() => [
          O(i.$slots, "optionPdf", {}, void 0, !0)
        ]),
        key: "1"
      } : void 0,
      i.$slots.optionCsv ? {
        name: "optionCsv",
        fn: z(() => [
          O(i.$slots, "optionCsv", {}, void 0, !0)
        ]),
        key: "2"
      } : void 0,
      i.$slots.optionImg ? {
        name: "optionImg",
        fn: z(() => [
          O(i.$slots, "optionImg", {}, void 0, !0)
        ]),
        key: "3"
      } : void 0,
      i.$slots.optionTable ? {
        name: "optionTable",
        fn: z(() => [
          O(i.$slots, "optionTable", {}, void 0, !0)
        ]),
        key: "4"
      } : void 0,
      i.$slots.optionLabels ? {
        name: "optionLabels",
        fn: z(() => [
          O(i.$slots, "optionLabels", {}, void 0, !0)
        ]),
        key: "5"
      } : void 0,
      i.$slots.optionStack ? {
        name: "optionStack",
        fn: z(() => [
          O(i.$slots, "optionStack", {}, void 0, !0)
        ]),
        key: "6"
      } : void 0,
      i.$slots.optionFullscreen ? {
        name: "optionFullscreen",
        fn: z(({ toggleFullscreen: a, isFullscreen: o }) => [
          O(i.$slots, "optionFullscreen", H(W({ toggleFullscreen: a, isFullscreen: o })), void 0, !0)
        ]),
        key: "7"
      } : void 0,
      i.$slots.optionAnnotator ? {
        name: "optionAnnotator",
        fn: z(({ toggleAnnotator: a, isAnnotator: o }) => [
          O(i.$slots, "optionAnnotator", H(W({ toggleAnnotator: a, isAnnotator: o })), void 0, !0)
        ]),
        key: "8"
      } : void 0
    ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasLabel", "hasTable", "hasStack", "hasFullscreen", "isStacked", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "hasAnnotator", "isAnnotation", "onToggleFullscreen", "onGeneratePdf", "onGenerateCsv", "onGenerateImage", "onToggleTable", "onToggleLabels", "onToggleStack", "onToggleTooltip", "onToggleAnnotator"])) : c("", !0),
    e.isDataset ? (r(), l("svg", {
      key: 4,
      xmlns: "http://www.w3.org/2000/svg",
      class: V([{ "vue-data-ui-fullscreen--on": t.isFullscreen, "vue-data-ui-fulscreen--off": !t.isFullscreen }, "vue-ui-xy-svg"]),
      width: "100%",
      viewBox: t.viewBox,
      style: C(`background: transparent; color:${e.FINAL_CONFIG.chart.color}; font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      X(m),
      e.maxSeries > 0 ? (r(), l("g", Ke, [
        g("g", Qe, [
          e.FINAL_CONFIG.chart.grid.labels.xAxis.showBaseline ? (r(), l("line", {
            key: 0,
            stroke: e.FINAL_CONFIG.chart.grid.stroke,
            "stroke-width": "1",
            x1: e.drawingArea.left + e.xPadding,
            x2: e.drawingArea.right - e.xPadding,
            y1: e.drawingArea.bottom,
            y2: e.drawingArea.bottom,
            "stroke-linecap": "round"
          }, null, 8, je)) : c("", !0),
          t.mutableConfig.useIndividualScale ? e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (r(!0), l(N, { key: 2 }, I(e.allScales, (a) => (r(), l("g", null, [
            a.id === t.selectedScale && a.yLabels.length ? (r(!0), l(N, { key: 0 }, I(a.yLabels, (o) => (r(), l("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(o.y),
              y2: e.checkNaN(o.y),
              stroke: a.color,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, it))), 256)) : a.yLabels.length ? (r(!0), l(N, { key: 1 }, I(a.yLabels, (o) => (r(), l("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.checkNaN(o.y),
              y2: e.checkNaN(o.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, at))), 256)) : c("", !0)
          ]))), 256)) : c("", !0) : (r(), l(N, { key: 1 }, [
            e.FINAL_CONFIG.chart.grid.labels.yAxis.showBaseline ? (r(), l("line", {
              key: 0,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-linecap": "round"
            }, null, 8, $e)) : c("", !0),
            e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (r(), l("g", et, [
              (r(!0), l(N, null, I(e.yLabels, (a) => (r(), l("line", {
                x1: e.drawingArea.left + e.xPadding,
                x2: e.drawingArea.right - e.xPadding,
                y1: e.checkNaN(a.y),
                y2: e.checkNaN(a.y),
                stroke: e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-width": 0.5,
                "stroke-linecap": "round"
              }, null, 8, tt))), 256))
            ])) : c("", !0)
          ], 64)),
          e.FINAL_CONFIG.chart.grid.showVerticalLines ? (r(), l("g", rt, [
            (r(!0), l(N, null, I(e.maxSeries + (e.FINAL_CONFIG.chart.grid.position === "middle" ? 1 : 0), (a, o) => (r(), l("line", {
              key: `grid_vertical_line_${o}`,
              x1: e.drawingArea.width / e.maxSeries * o + e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.width / e.maxSeries * o + e.drawingArea.left + e.xPadding,
              y1: e.drawingArea.top,
              y2: e.drawingArea.bottom,
              "stroke-width": "0.5",
              stroke: e.FINAL_CONFIG.chart.grid.stroke
            }, null, 8, lt))), 128))
          ])) : c("", !0)
        ]),
        (r(!0), l(N, null, I(e.barSet, (a, o) => (r(), l("defs", {
          key: `def_rect_${o}`
        }, [
          g("linearGradient", {
            id: `rectGradient_pos_${o}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": a.color
            }, null, 8, nt),
            g("stop", {
              offset: "62%",
              "stop-color": `${e.shiftHue(a.color, 0.02)}`
            }, null, 8, ot),
            g("stop", {
              offset: "100%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, ct)
          ], 8, st),
          g("linearGradient", {
            id: `rectGradient_neg_${o}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, dt),
            g("stop", {
              offset: "38%",
              "stop-color": `${e.shiftHue(a.color, 0.02)}`
            }, null, 8, ut),
            g("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, gt)
          ], 8, ht)
        ]))), 128)),
        (r(!0), l(N, null, I(e.plotSet, (a, o) => (r(), l("defs", {
          key: `def_plot_${o}`
        }, [
          g("radialGradient", {
            id: `plotGradient_${o}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, Nt),
            g("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, mt)
          ], 8, ft)
        ]))), 128)),
        (r(!0), l(N, null, I(e.lineSet, (a, o) => (r(), l("defs", {
          key: `def_line_${o}`
        }, [
          g("radialGradient", {
            id: `lineGradient_${o}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(a.color, 0.05)}`
            }, null, 8, xt),
            g("stop", {
              offset: "100%",
              "stop-color": a.color
            }, null, 8, bt)
          ], 8, It),
          g("linearGradient", {
            id: `areaGradient_${o}_${t.uniqueId}`,
            x1: "0%",
            x2: "100%",
            y1: "0%",
            y2: "0%"
          }, [
            g("stop", {
              offset: "0%",
              "stop-color": `${e.setOpacity(e.shiftHue(a.color, 0.03), e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, _t),
            g("stop", {
              offset: "100%",
              "stop-color": `${e.setOpacity(a.color, e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, yt)
          ], 8, Ft)
        ]))), 128)),
        (r(!0), l(N, null, I(e.highlightAreas, (a) => (r(), l("g", null, [
          a.show ? (r(!0), l(N, { key: 0 }, I(a.span, (o, n) => (r(), l("g", null, [
            g("rect", {
              style: C({
                transition: "none",
                opacity: a.from + n >= t.slicer.start && a.from + n <= t.slicer.end - 1 ? 1 : 0
              }),
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (a.from + n - t.slicer.start),
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: e.setOpacity(a.color, a.opacity)
            }, null, 12, At),
            a.caption.text && n === 0 ? (r(), l("foreignObject", {
              key: 0,
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (a.from + n - t.slicer.start) - (a.caption.width === "auto" ? 0 : a.caption.width / 2 - e.drawingArea.width / e.maxSeries * a.span / 2),
              y: e.drawingArea.top + a.caption.offsetY,
              style: C({
                overflow: "visible",
                opacity: a.to >= t.slicer.start && a.from < t.slicer.end ? 1 : 0
              }),
              height: "1",
              width: a.caption.width === "auto" ? e.drawingArea.width / e.maxSeries * a.span : a.caption.width
            }, [
              g("div", {
                style: C(`padding:${a.caption.padding}px;text-align:${a.caption.textAlign};font-size:${a.caption.fontSize}px;color:${a.caption.color};font-weight:${a.caption.bold ? "bold" : "normal"}`)
              }, S(a.caption.text), 5)
            ], 12, Ct)) : c("", !0)
          ]))), 256)) : c("", !0)
        ]))), 256)),
        g("g", null, [
          (r(!0), l(N, null, I(e.maxSeries, (a, o) => (r(), l("g", {
            key: `tooltip_trap_highlighter_${o}`
          }, [
            g("rect", {
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * o,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: [t.selectedMinimapIndex, t.selectedSerieIndex, t.selectedRowIndex].includes(o) ? e.setOpacity(e.FINAL_CONFIG.chart.highlighter.color, e.FINAL_CONFIG.chart.highlighter.opacity) : "transparent"
            }, null, 8, Lt)
          ]))), 128))
        ]),
        e.barSet.length ? (r(!0), l(N, { key: 0 }, I(e.barSet, (a, o) => (r(), l("g", {
          key: `serie_bar_${o}`,
          class: V(`serie_bar_${o}`),
          style: C(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(N, null, I(a.plots, (n, d) => (r(), l("g", {
            key: `bar_plot_${o}_${d}`
          }, [
            e.canShowValue(n.value) ? (r(), l("rect", {
              key: 0,
              x: e.calcRectX(n),
              y: t.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: t.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: e.FINAL_CONFIG.bar.useGradient ? n.value >= 0 ? `url(#rectGradient_pos_${o}_${t.uniqueId})` : `url(#rectGradient_neg_${o}_${t.uniqueId})` : a.color,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? a.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, St)) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: (e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) / 2) + e.FINAL_CONFIG.chart.comments.width,
              x: e.calcRectX(n) - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: e.checkNaN(n.y) + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              O(i.$slots, "plot-comment", {
                plot: { ...n, color: a.color, seriesIndex: o, datapointIndex: d }
              }, void 0, !0)
            ], 8, kt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (r(), l("g", wt, [
            g("defs", null, [
              g("marker", {
                id: `bar_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                g("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, Gt)
              ], 8, Ot)
            ]),
            a.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#bar_arrow_${o})`
            }, null, 8, vt)) : c("", !0),
            a.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: a.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, pt)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)) : c("", !0),
        !t.mutableConfig.useIndividualScale && e.FINAL_CONFIG.chart.grid.labels.zeroLine.show ? (r(), l("line", {
          key: 1,
          stroke: e.FINAL_CONFIG.chart.grid.stroke,
          "stroke-width": "1",
          x1: e.drawingArea.left + e.xPadding,
          x2: e.drawingArea.right - e.xPadding,
          y1: e.checkNaN(e.zero),
          y2: e.checkNaN(e.zero),
          "stroke-linecap": "round"
        }, null, 8, Mt)) : c("", !0),
        e.FINAL_CONFIG.chart.highlighter.useLine && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (r(), l("g", zt, [
          g("line", {
            x1: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            x2: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            y1: e.drawingArea.top,
            y2: e.drawingArea.bottom,
            stroke: e.FINAL_CONFIG.chart.highlighter.color,
            "stroke-width": e.FINAL_CONFIG.chart.highlighter.lineWidth,
            "stroke-dasharray": e.FINAL_CONFIG.chart.highlighter.lineDasharray,
            "stroke-linecap": "round",
            style: { transition: "none !important", animation: "none !important", "pointer-events": "none" }
          }, null, 8, Tt)
        ])) : c("", !0),
        e.FINAL_CONFIG.chart.grid.frame.show ? (r(), l("rect", {
          key: 3,
          style: { pointerEvents: "none", transition: "none" },
          x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
          y: e.drawingArea.top,
          width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
          height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
          fill: "transparent",
          stroke: e.FINAL_CONFIG.chart.grid.frame.stroke,
          "stroke-width": e.FINAL_CONFIG.chart.grid.frame.strokeWidth,
          "stroke-linecap": e.FINAL_CONFIG.chart.grid.frame.strokeLinecap,
          "stroke-linejoin": e.FINAL_CONFIG.chart.grid.frame.strokeLinejoin,
          "stroke-dasharray": e.FINAL_CONFIG.chart.grid.frame.strokeDasharray
        }, null, 8, Pt)) : c("", !0),
        e.FINAL_CONFIG.chart.grid.labels.show ? (r(), l("g", Vt, [
          t.mutableConfig.useIndividualScale ? (r(), l(N, { key: 0 }, [
            (r(!0), l(N, null, I(e.allScales, (a) => (r(), l("g", null, [
              g("line", {
                x1: a.x + e.xPadding,
                x2: a.x + e.xPadding,
                y1: t.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - a.yOffset - a.individualHeight) : e.checkNaN(e.drawingArea.top),
                y2: t.mutableConfig.isStacked ? e.checkNaN(e.drawingArea.bottom - a.yOffset) : e.checkNaN(e.drawingArea.bottom),
                stroke: a.color,
                "stroke-width": e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-linecap": "round",
                style: C(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
              }, null, 12, Rt)
            ]))), 256)),
            (r(!0), l(N, null, I(e.allScales, (a) => (r(), l("g", {
              style: C(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
            }, [
              g("text", {
                fill: a.color,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "middle",
                transform: `translate(${a.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + 5}, ${t.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset - a.individualHeight / 2 : e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`
              }, S(a.name) + " " + S(a.scaleLabel ? `- ${a.scaleLabel}` : ""), 9, Dt),
              (r(!0), l(N, null, I(a.yLabels, (o, n) => (r(), l("line", {
                x1: a.x - 3 + e.xPadding,
                x2: a.x + e.xPadding,
                y1: e.checkNaN(o.y),
                y2: e.checkNaN(o.y),
                stroke: a.color,
                "stroke-width": 1,
                "stroke-linecap": "round"
              }, null, 8, Bt))), 256)),
              (r(!0), l(N, null, I(a.yLabels, (o, n) => (r(), l("text", {
                x: a.x - 5 + e.xPadding,
                y: e.checkNaN(o.y) + t.fontSizes.dataLabels / 3,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "end",
                fill: a.color
              }, S(e.applyDataLabel(
                e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
                o.value,
                e.dataLabel({
                  p: o.prefix,
                  v: o.value,
                  s: o.suffix,
                  r: 1
                }),
                { datapoint: o.datapoint, seriesIndex: n }
              )), 9, Ht))), 256))
            ], 4))), 256))
          ], 64)) : (r(!0), l(N, { key: 1 }, I(e.yLabels, (a, o) => (r(), l("g", {
            key: `yLabel_${o}`
          }, [
            e.canShowValue(a) && a.value >= e.niceScale.min && a.value <= e.niceScale.max ? (r(), l("line", {
              key: 0,
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left - 5 + e.xPadding,
              y1: e.checkNaN(a.y),
              y2: e.checkNaN(a.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              "stroke-linecap": "round"
            }, null, 8, Wt)) : c("", !0),
            a.value >= e.niceScale.min && a.value <= e.niceScale.max ? (r(), l("text", {
              key: 1,
              x: e.drawingArea.left - 7 + e.xPadding,
              y: e.checkNaN(a.y + t.fontSizes.dataLabels / 3),
              "font-size": t.fontSizes.dataLabels,
              "text-anchor": "end",
              fill: e.FINAL_CONFIG.chart.grid.labels.color
            }, S(e.canShowValue(a.value) ? e.applyDataLabel(
              e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
              a.value,
              e.dataLabel({
                p: a.prefix,
                v: a.value,
                s: a.suffix,
                r: 1
              })
            ) : ""), 9, Et)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        (r(!0), l(N, null, I(e.plotSet, (a, o) => (r(), l("g", {
          key: `serie_plot_${o}`,
          class: V(`serie_plot_${o}`),
          style: C(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(N, null, I(a.plots, (n, d) => (r(), l("g", {
            key: `circle_plot_${o}_${d}`
          }, [
            n && e.canShowValue(n.value) ? (r(), D(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
              color: e.FINAL_CONFIG.plot.useGradient ? `url(#plotGradient_${o}_${t.uniqueId})` : e.FINAL_CONFIG.plot.dot.useSerieColor ? a.color : e.FINAL_CONFIG.plot.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (t.plotRadii.plot || 6) * 1.5 : t.plotRadii.plot || 6,
              stroke: e.FINAL_CONFIG.plot.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : a.color,
              strokeWidth: e.FINAL_CONFIG.plot.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              g("div", Xt, [
                O(i.$slots, "plot-comment", {
                  plot: { ...n, color: a.color, seriesIndex: o, datapointIndex: d }
                }, void 0, !0)
              ])
            ], 8, Yt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (r(), l("g", qt, [
            g("defs", null, [
              g("marker", {
                id: `plot_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                g("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, Zt)
              ], 8, Ut)
            ]),
            a.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#plot_arrow_${o})`
            }, null, 8, Jt)) : c("", !0),
            a.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: a.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Kt)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (r(!0), l(N, null, I(e.lineSet, (a, o) => (r(), l("g", {
          key: `serie_line_${o}`,
          class: V(`serie_line_${o}`),
          style: C(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          a.smooth && a.plots.length > 1 ? (r(), l("path", {
            key: 0,
            d: `M${a.curve}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, Qt)) : a.plots.length > 1 ? (r(), l("g", jt, [
            (r(!0), l(N, null, I(a.plots, (n, d) => (r(), l("g", {
              key: `line_${o}_${d}`
            }, [
              n && d < a.plots.length - 1 && a.plots[d + 1] && e.canShowValue(n.value) && e.canShowValue(a.plots[d + 1].value) ? (r(), l("line", {
                key: 0,
                x1: n.x,
                x2: a.plots[d + 1].x,
                y1: n.y,
                y2: a.plots[d + 1].y,
                stroke: e.FINAL_CONFIG.chart.backgroundColor,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
                "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, $t)) : c("", !0)
            ]))), 128))
          ])) : c("", !0)
        ], 6))), 128)),
        (r(!0), l(N, null, I(e.lineSet, (a, o) => (r(), l("g", {
          key: `serie_line_${o}`,
          class: V(`serie_line_${o}`),
          style: C(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          a.useArea && a.plots.length > 1 ? (r(), l("g", ei, [
            a.smooth ? (r(), l("path", {
              key: 0,
              d: `M ${a.plots[0] ? a.plots[0].x : Math.min(...a.plots.filter((n) => !!n).map((n) => n.x))},${t.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset : e.drawingArea.bottom} ${a.curve} L ${a.plots.at(-1) ? a.plots.at(-1).x : e.drawingArea.left + e.slot.line * o + e.slot.line / 2},${t.mutableConfig.isStacked ? e.drawingArea.bottom - a.yOffset : e.drawingArea.bottom} Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${o}_${t.uniqueId})` : e.setOpacity(a.color, e.FINAL_CONFIG.line.area.opacity)
            }, null, 8, ti)) : (r(), l("path", {
              key: 1,
              d: `M${a.area}Z`,
              fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${o}_${t.uniqueId})` : e.setOpacity(a.color, e.FINAL_CONFIG.line.area.opacity)
            }, null, 8, ii))
          ])) : c("", !0),
          a.smooth && a.plots.length > 1 ? (r(), l("path", {
            key: 1,
            d: `M${a.curve}`,
            stroke: a.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, ai)) : a.plots.length > 1 ? (r(), l("g", ri, [
            (r(!0), l(N, null, I(a.plots, (n, d) => (r(), l("g", {
              key: `line_${o}_${d}`
            }, [
              n && d < a.plots.length - 1 && a.plots[d + 1] && e.canShowValue(n.value) && e.canShowValue(a.plots[d + 1].value) ? (r(), l("line", {
                key: 0,
                x1: n.x,
                x2: a.plots[d + 1].x,
                y1: n.y,
                y2: a.plots[d + 1].y,
                stroke: a.color,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
                "stroke-dasharray": a.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, li)) : c("", !0)
            ]))), 128))
          ])) : c("", !0),
          (r(!0), l(N, null, I(a.plots, (n, d) => (r(), l("g", {
            key: `circle_line_${o}_${d}`
          }, [
            n && e.canShowValue(n.value) ? (r(), D(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
              color: e.FINAL_CONFIG.line.useGradient ? `url(#lineGradient_${o}_${t.uniqueId})` : e.FINAL_CONFIG.line.dot.useSerieColor ? a.color : e.FINAL_CONFIG.line.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (t.plotRadii.line || 6) * 1.5 : t.plotRadii.line || 6,
              stroke: e.FINAL_CONFIG.line.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : a.color,
              strokeWidth: e.FINAL_CONFIG.line.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (r(), l("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              g("div", ni, [
                O(i.$slots, "plot-comment", {
                  plot: { ...n, color: a.color, seriesIndex: o, datapointIndex: d }
                }, void 0, !0)
              ])
            ], 8, si)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(a, "useProgression") && a.useProgression === !0 && !isNaN(e.calcLinearProgression(a.plots).trend) ? (r(), l("g", oi, [
            g("defs", null, [
              g("marker", {
                id: `line_arrow_${o}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                g("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: a.color
                }, null, 8, hi)
              ], 8, ci)
            ]),
            a.plots.length > 1 ? (r(), l("line", {
              key: 0,
              x1: e.calcLinearProgression(a.plots).x1,
              x2: e.calcLinearProgression(a.plots).x2,
              y1: e.calcLinearProgression(a.plots).y1,
              y2: e.calcLinearProgression(a.plots).y2,
              "stroke-width": 1,
              stroke: a.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#line_arrow_${o})`
            }, null, 8, di)) : c("", !0),
            a.plots.length > 1 ? (r(), l("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(a.plots).x2,
              y: e.calcLinearProgression(a.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: a.color
            }, S(e.dataLabel({
              v: e.calcLinearProgression(a.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, ui)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (e.FINAL_CONFIG.bar.labels.show || e.FINAL_CONFIG.bar.serieName.show) && t.mutableConfig.dataLabels.show ? (r(), l("g", gi, [
          (r(!0), l(N, null, I(e.barSet, (a, o) => (r(), l("g", {
            key: `xLabel_bar_${o}`,
            class: V(`xLabel_bar_${o}`),
            style: C(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(N, null, I(a.plots, (n, d) => (r(), l("g", {
              key: `xLabel_bar_${o}_${d}`
            }, [
              n && (!Object.hasOwn(a, "dataLabels") || a.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d) && e.FINAL_CONFIG.bar.labels.show ? (r(), l("text", {
                key: 0,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : e.calcRectX(n) + e.calcRectWidth() / 2 - e.barPeriodGap / 2,
                y: e.checkNaN(n.y) + (n.value >= 0 ? e.FINAL_CONFIG.bar.labels.offsetY : -e.FINAL_CONFIG.bar.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.bar.labels.formatter,
                n.value,
                e.dataLabel({
                  p: a.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: a.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.bar.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, fi)) : c("", !0),
              n && e.FINAL_CONFIG.bar.serieName.show ? (r(), l("text", {
                key: 1,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : n.x + e.calcRectWidth() * 1.1,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.serieName.offsetY : -e.FINAL_CONFIG.bar.serieName.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.serieName.useSerieColor ? a.color : e.FINAL_CONFIG.bar.serieName.color,
                "font-weight": e.FINAL_CONFIG.bar.serieName.bold ? "bold" : "normal"
              }, S(e.FINAL_CONFIG.bar.serieName.useAbbreviation ? e.abbreviate({ source: a.name, length: e.FINAL_CONFIG.bar.serieName.abbreviationSize }) : a.name), 9, Ni)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.plot.labels.show && t.mutableConfig.dataLabels.show ? (r(), l("g", mi, [
          (r(!0), l(N, null, I(e.plotSet, (a, o) => (r(), l("g", {
            key: `xLabel_plot_${o}`,
            class: V(`xLabel_plot_${o}`),
            style: C(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(N, null, I(a.plots, (n, d) => (r(), l("g", {
              key: `xLabel_plot_${o}_${d}`
            }, [
              n && !Object.hasOwn(a, "dataLabels") || a.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (r(), l("text", {
                key: 0,
                x: n.x,
                y: n.y + e.FINAL_CONFIG.plot.labels.offsetY,
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.plot.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.plot.labels.formatter,
                n.value,
                e.dataLabel({
                  p: a.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: a.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.plot.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, Ii)) : c("", !0),
              n && d === 0 && a.useTag && a.useTag === "start" ? (r(), l("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                g("div", {
                  style: C(`padding: 3px; background:${e.setOpacity(a.color, 80)};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, xi)) : c("", !0),
              n && d === a.plots.length - 1 && a.useTag && a.useTag === "end" ? (r(), l("foreignObject", {
                key: 2,
                x: n.x - a.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                g("div", {
                  style: C(`padding: 3px; background:${e.setOpacity(a.color, 80)};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, bi)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.line.labels.show && t.mutableConfig.dataLabels.show ? (r(), l("g", Fi, [
          (r(!0), l(N, null, I(e.lineSet, (a, o) => (r(), l("g", {
            key: `xLabel_line_${o}`,
            class: V(`xLabel_line_${o}`),
            style: C(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (r(!0), l(N, null, I(a.plots, (n, d) => (r(), l("g", {
              key: `xLabel_line_${o}_${d}`
            }, [
              n && !Object.hasOwn(a, "dataLabels") || a.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (r(), l("text", {
                key: 0,
                x: n.x,
                y: n.y + (n.value >= 0 ? e.FINAL_CONFIG.line.labels.offsetY : -e.FINAL_CONFIG.line.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.line.labels.color
              }, S(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.line.labels.formatter,
                n.value,
                e.dataLabel({
                  p: a.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: a.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.line.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: a
                }
              ) : ""), 9, _i)) : c("", !0),
              n && d === 0 && a.useTag && a.useTag === "start" ? (r(), l("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                g("div", {
                  style: C(`padding: 3px; background:${e.setOpacity(a.color, 80)};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, yi)) : c("", !0),
              n && d === a.plots.length - 1 && a.useTag && a.useTag === "end" ? (r(), l("foreignObject", {
                key: 2,
                x: n.x - a.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                g("div", {
                  style: C(`padding: 3px; background:${e.setOpacity(a.color, 80)};color:${e.adaptColorToBackground(a.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, S(a.name), 5)
              ], 8, Ai)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        (r(!0), l(N, null, I(e.lineSet, (a, o) => (r(), l("g", {
          key: `xLabel_line_${o}`,
          class: V(`xLabel_line_${o}`),
          style: C(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(N, null, I(a.plots, (n, d) => (r(), l("g", {
            key: `xLabel_line_${o}_${d}`
          }, [
            n && d === 0 && a.showSerieName && a.showSerieName === "start" ? (r(), l("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Ci)) : c("", !0),
            n && d === a.plots.length - 1 && a.showSerieName && a.showSerieName === "end" ? (r(), l("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Li)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        (r(!0), l(N, null, I(e.plotSet, (a, o) => (r(), l("g", {
          key: `xLabel_plot_${o}`,
          class: V(`xLabel_plot_${o}`),
          style: C(`opacity:${t.selectedScale ? t.selectedScale === a.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (r(!0), l(N, null, I(a.plots, (n, d) => (r(), l("g", {
            key: `xLabel_plot_${o}_${d}`
          }, [
            n && d === 0 && a.showSerieName && a.showSerieName === "start" ? (r(), l("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Si)) : c("", !0),
            n && d === a.plots.length - 1 && a.showSerieName && a.showSerieName === "end" ? (r(), l("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: a.color,
              innerHTML: e.createTSpans({
                content: a.name,
                fontSize: t.fontSizes.plotLabels,
                fill: a.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, ki)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        t.mutableConfig.useIndividualScale && !t.mutableConfig.isStacked ? (r(!0), l(N, { key: 8 }, I(e.allScales, (a) => (r(), l("rect", {
          x: a.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          y: e.drawingArea.top,
          width: e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
          fill: t.selectedScale === a.id ? e.setOpacity(a.color, 20) : "transparent",
          onMouseenter: (o) => t.selectedScale = a.id,
          onMouseleave: s[0] || (s[0] = (o) => t.selectedScale = null)
        }, null, 40, wi))), 256)) : c("", !0),
        g("g", null, [
          e.FINAL_CONFIG.chart.grid.labels.axis.yLabel && !t.mutableConfig.useIndividualScale ? (r(), l("text", {
            key: 0,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color,
            transform: `translate(${t.fontSizes.yAxis + e.FINAL_CONFIG.chart.grid.labels.axis.yLabelOffsetX}, ${e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`,
            "text-anchor": "middle",
            style: { transition: "none" }
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.yLabel), 9, Oi)) : c("", !0),
          e.FINAL_CONFIG.chart.grid.labels.axis.xLabel ? (r(), l("text", {
            key: 1,
            "text-anchor": "middle",
            x: t.width / 2,
            y: e.drawingArea.bottom + t.fontSizes.yAxis + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.axis.xLabelOffsetY,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color
          }, S(e.FINAL_CONFIG.chart.grid.labels.axis.xLabel), 9, Gi)) : c("", !0)
        ]),
        e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.show ? (r(), l("g", vi, [
          (r(!0), l(N, null, I(e.timeLabels, (a, o) => (r(), l("g", {
            key: `time_label_${o}`
          }, [
            a && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (o === 0 || o === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === o && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || a && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && o % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0 ? (r(), l("text", {
              key: 0,
              "text-anchor": e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              "font-size": t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * o + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`
            }, S(a || ""), 9, pi)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        g("g", null, [
          (r(!0), l(N, null, I(e.maxSeries, (a, o) => (r(), l("g", {
            key: `tooltip_trap_${o}`
          }, [
            g("rect", {
              "data-cy-trap": "",
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * o,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: "transparent",
              onMouseenter: (n) => e.toggleTooltipVisibility(!0, o),
              onMouseleave: s[1] || (s[1] = (n) => e.toggleTooltipVisibility(!1)),
              onClick: (n) => e.selectX(o)
            }, null, 40, Mi)
          ]))), 128))
        ]),
        e.FINAL_CONFIG.chart.timeTag.show && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (r(), l("g", zi, [
          (r(), l("foreignObject", {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) - 100 + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom,
            width: "200",
            height: "40",
            style: { overflow: "visible !important" }
          }, [
            g("div", {
              class: "vue-ui-xy-time-tag",
              style: C(`width: fit-content;margin: 0 auto;text-align:center;padding:3px 12px;background:${e.FINAL_CONFIG.chart.timeTag.backgroundColor};color:${e.FINAL_CONFIG.chart.timeTag.color};font-size:${e.FINAL_CONFIG.chart.timeTag.fontSize}px`)
            }, S(e.timeLabels[(t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)] || (t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)), 5)
          ], 8, Ti)),
          g("circle", {
            cx: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            cy: e.drawingArea.bottom,
            r: e.FINAL_CONFIG.chart.timeTag.circleMarker.radius,
            fill: e.FINAL_CONFIG.chart.timeTag.circleMarker.color
          }, null, 8, Pi)
        ])) : c("", !0)
      ])) : c("", !0),
      O(i.$slots, "svg", { svg: e.svg }, void 0, !0)
    ], 14, Je)) : c("", !0),
    i.$slots.watermark ? (r(), l("div", Vi, [
      O(i.$slots, "watermark", H(W({ isPrinting: t.isPrinting || t.isImaging })), void 0, !0)
    ])) : c("", !0),
    e.isDataset ? c("", !0) : (r(), D(T, {
      key: 6,
      config: {
        type: "line",
        style: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          line: {
            axis: {
              color: e.FINAL_CONFIG.chart.grid.stroke
            },
            path: {
              color: e.FINAL_CONFIG.chart.grid.stroke,
              strokeWidth: 0.5
            }
          }
        }
      }
    }, null, 8, ["config"])),
    e.FINAL_CONFIG.chart.zoom.show && t.maxX > 6 && e.isDataset ? (r(), D(v, {
      ref: "chartSlicer",
      key: `slicer_${t.slicerStep}`,
      background: e.FINAL_CONFIG.chart.zoom.color,
      fontSize: e.FINAL_CONFIG.chart.zoom.fontSize,
      useResetSlot: e.FINAL_CONFIG.chart.zoom.useResetSlot,
      labelLeft: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.start],
      labelRight: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.end - 1],
      textColor: e.FINAL_CONFIG.chart.color,
      inputColor: e.FINAL_CONFIG.chart.zoom.color,
      selectColor: e.FINAL_CONFIG.chart.zoom.highlightColor,
      borderColor: e.FINAL_CONFIG.chart.backgroundColor,
      minimap: e.minimap,
      smoothMinimap: e.FINAL_CONFIG.chart.zoom.minimap.smooth,
      minimapSelectedColor: e.FINAL_CONFIG.chart.zoom.minimap.selectedColor,
      minimapSelectionRadius: e.FINAL_CONFIG.chart.zoom.minimap.selectionRadius,
      minimapLineColor: e.FINAL_CONFIG.chart.zoom.minimap.lineColor,
      minimapSelectedColorOpacity: e.FINAL_CONFIG.chart.zoom.minimap.selectedColorOpacity,
      minimapSelectedIndex: t.selectedSerieIndex,
      minimapIndicatorColor: e.FINAL_CONFIG.chart.zoom.minimap.indicatorColor,
      max: t.maxX,
      min: 0,
      valueStart: t.slicer.start,
      valueEnd: t.slicer.end,
      start: t.slicer.start,
      "onUpdate:start": s[2] || (s[2] = (a) => t.slicer.start = a),
      end: t.slicer.end,
      "onUpdate:end": s[3] || (s[3] = (a) => t.slicer.end = a),
      onReset: e.refreshSlicer,
      onTrapMouse: e.selectMinimapIndex
    }, {
      "reset-action": z(({ reset: a }) => [
        O(i.$slots, "reset-action", H(W({ reset: a })), void 0, !0)
      ]),
      _: 3
    }, 8, ["background", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "borderColor", "minimap", "smoothMinimap", "minimapSelectedColor", "minimapSelectionRadius", "minimapLineColor", "minimapSelectedColorOpacity", "minimapSelectedIndex", "minimapIndicatorColor", "max", "valueStart", "valueEnd", "start", "end", "onReset", "onTrapMouse"])) : c("", !0),
    e.FINAL_CONFIG.chart.legend.show ? (r(), l("div", {
      key: 8,
      ref: "chartLegend",
      class: "vue-ui-xy-legend",
      style: C(`font-size:${e.FINAL_CONFIG.chart.legend.fontSize}px`)
    }, [
      (r(!0), l(N, null, I(e.absoluteDataset, (a, o) => (r(), l("div", {
        key: `div_legend_item_${o}`,
        onClick: (n) => e.segregate(a),
        class: V({ "vue-ui-xy-legend-item": !0, "vue-ui-xy-legend-item-segregated": t.segregatedSeries.includes(a.id) })
      }, [
        t.icons[a.type] === "line" ? (r(), l("svg", Di, [
          g("rect", {
            x: "0",
            y: "7",
            rx: "3",
            stroke: "none",
            height: "4",
            width: "20",
            fill: a.color
          }, null, 8, Bi),
          X(b, {
            plot: { x: 10, y: 9 },
            radius: 4,
            color: a.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            strokeWidth: 1
          }, null, 8, ["color", "shape", "stroke"])
        ])) : (r(), l("svg", Hi, [
          t.icons[a.type] === "bar" ? (r(), l("rect", {
            key: 0,
            x: "0",
            y: "0",
            rx: "1",
            height: "12",
            width: "12",
            stroke: "none",
            fill: a.color
          }, null, 8, Wi)) : (r(), D(b, {
            key: 1,
            plot: { x: 6, y: 6 },
            radius: 5,
            color: a.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(a.shape) ? a.shape : "circle"
          }, null, 8, ["color", "shape"]))
        ])),
        g("span", {
          style: C(`color:${e.FINAL_CONFIG.chart.legend.color}`)
        }, S(a.name), 5)
      ], 10, Ri))), 128))
    ], 4)) : (r(), l("div", Ei, [
      O(i.$slots, "legend", { legend: e.absoluteDataset }, void 0, !0)
    ], 512)),
    i.$slots.source ? (r(), l("div", Yi, [
      O(i.$slots, "source", {}, void 0, !0)
    ], 512)) : c("", !0),
    X(p, {
      show: t.mutableConfig.showTooltip && t.isTooltip,
      backgroundColor: e.FINAL_CONFIG.chart.tooltip.backgroundColor,
      color: e.FINAL_CONFIG.chart.tooltip.color,
      fontSize: e.FINAL_CONFIG.chart.tooltip.fontSize,
      borderRadius: e.FINAL_CONFIG.chart.tooltip.borderRadius,
      borderColor: e.FINAL_CONFIG.chart.tooltip.borderColor,
      borderWidth: e.FINAL_CONFIG.chart.tooltip.borderWidth,
      backgroundOpacity: e.FINAL_CONFIG.chart.tooltip.backgroundOpacity,
      position: e.FINAL_CONFIG.chart.tooltip.position,
      offsetY: e.FINAL_CONFIG.chart.tooltip.offsetY,
      parent: i.$refs.chart,
      content: e.tooltipContent,
      isCustom: e.FINAL_CONFIG.chart.tooltip.customFormat && typeof e.FINAL_CONFIG.chart.tooltip.customFormat == "function"
    }, {
      "tooltip-before": z(() => [
        O(i.$slots, "tooltip-before", H(W({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      "tooltip-after": z(() => [
        O(i.$slots, "tooltip-after", H(W({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      _: 3
    }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
    e.isDataset ? (r(), D(M, {
      key: 11,
      hideDetails: "",
      config: {
        open: t.mutableConfig.showTable,
        maxHeight: 1e4,
        body: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        },
        head: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        }
      }
    }, {
      content: z(() => [
        g("div", {
          style: C(`${t.isPrinting ? "" : "max-height:400px"};overflow:auto;width:100%;margin-top:48px`)
        }, [
          g("div", Xi, [
            He(g("input", {
              type: "checkbox",
              "onUpdate:modelValue": s[4] || (s[4] = (a) => t.showSparklineTable = a)
            }, null, 512), [
              [We, t.showSparklineTable]
            ]),
            g("div", {
              onClick: s[5] || (s[5] = (a) => t.showSparklineTable = !t.showSparklineTable),
              style: { cursor: "pointer" }
            }, [
              X(w, {
                name: "chartLine",
                size: 20,
                stroke: e.FINAL_CONFIG.chart.color
              }, null, 8, ["stroke"])
            ])
          ]),
          t.showSparklineTable ? (r(), D(_, {
            key: `sparkline_${t.segregateStep}`,
            dataset: e.tableSparklineDataset,
            config: e.tableSparklineConfig
          }, null, 8, ["dataset", "config"])) : (r(), D(L, {
            key: `table_${t.tableStep}`,
            colNames: e.dataTable.colNames,
            head: e.dataTable.head,
            body: e.dataTable.body,
            config: e.dataTable.config,
            title: `${e.FINAL_CONFIG.chart.title.text}${e.FINAL_CONFIG.chart.title.subtitle.text ? ` : ${e.FINAL_CONFIG.chart.title.subtitle.text}` : ""}`,
            onClose: s[6] || (s[6] = (a) => t.mutableConfig.showTable = !1)
          }, {
            th: z(({ th: a }) => [
              g("div", { innerHTML: a }, null, 8, qi)
            ]),
            td: z(({ td: a }) => [
              Ee(S(isNaN(Number(a)) ? a : e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: a,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: e.FINAL_CONFIG.table.rounding
              })), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ], 4)
      ]),
      _: 1
    }, 8, ["config"])) : c("", !0)
  ], 14, Ue);
}
const ha = /* @__PURE__ */ Ye(qe, [["render", Ui], ["__scopeId", "data-v-3b05da9c"]]);
export {
  ha as default
};
